# metódy ako funkcie, ktoré sú súkromné pre danú triedu

class StudentVS:
    def assign_school(self, text):                                      # vytvorenie súkromnej funkcie (metódy) pre triedu StudentVS
        self.school = text                                              # prvý parameter metódy musí byť premenná, v ktorej metóda dostane inštanciu tejto triedy pre ďalšie spracovanie 
        print(self.name, self. surname+ ' študuje na '+ self.school)
    
    def assign_hobbies(self, text):
        self.hobbies = text
        print(self.name, self. surname+ ' má hoby '+ self.hobbies)


def assign(n, s):                                                       # globálna funkciu assign(), ktorá dostane na vstupe dva znakové reťazce a vytvorí z nich nový objekt typu StudentVS               
    person = StudentVS()
    person.name = n
    person.surname = s
    return person

boy=assign('Lukáš','Hríbik')
girl=assign('Lucia','Hubová')



StudentVS.assign_hobbies(boy, 'programovanie')                          # volanie metódy assign_hobbies cez bodkovú notáciu nad triedou StudentVS             
StudentVS.assign_school(boy, 'FEI TUKE')
girl.assign_hobbies('gitara')                                           # volanie metódy assign_hobbies cez bodkovú notáciu využitím inštancie girl    
girl.assign_school('FU TUKE')

print('------------------')






# magické metódy slúžia na inicializovanie atribútov daného objektu; takéto metódy majú definíciu úplne rovnakú ako bežné metódy 
# Python ich rozpozná podľa ich mena t.j. ich meno začína aj končí dvojicou podčiarkovníkov __

class Student_tuke:
    def __init__(self, meno, priezvisko, hoby=''):                     # jedna z najužitočnejších a najčastejšie definovaných magických metód
        self.name = meno
        self.surname = priezvisko
        self.hobbies = hoby
    
    def assign_school(self, text):
        self.school = text
        print(self.name, self. surname+ ' študuje na '+ self.school)
    
    def assign_hobbies(self, text):
        self.hobbies = text
        print(self.name, self. surname+ ' má hoby '+ self.hobbies)

newboy = Student_tuke('František', 'Kapusta')
#newboy.assign_hobbies('lietadlá')
newboy.assign_school('LF TUKE')

print('------------------')







# štandardná funkcia dir() vráti postupnosť (zoznam) všetkých atribútov triedy alebo inštancie

class Test:
    pass

print(dir(Test))

print(dir(Student_tuke))

print(dir(newboy))
